const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const approval_reviewers = sequelize.define(
    'approval_reviewers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

decision: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"approved",


"rejected"

        ],

      },

decided_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  approval_reviewers.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity































//end loop



    db.approval_reviewers.belongsTo(db.approvals, {
      as: 'approval',
      foreignKey: {
        name: 'approvalId',
      },
      constraints: false,
    });

    db.approval_reviewers.belongsTo(db.users, {
      as: 'reviewer',
      foreignKey: {
        name: 'reviewerId',
      },
      constraints: false,
    });

    db.approval_reviewers.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.approval_reviewers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.approval_reviewers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return approval_reviewers;
};


